//*****************************************************************************
//   +--+
//   | ++----+
//   +-++    |
//     |     |
//   +-+--+  |
//   | +--+--+
//   +----+    Copyright (c) 2009 Code Red Technologies Ltd.
//
// blockdev_flash.c - bottom layer for LPCUSB stack mass storage, providing
//                    access to LPC1768 flash memory for RDB1768 bootloader
//
// Software License Agreement
//
// The software is owned by Code Red Technologies and/or its suppliers, and is
// protected under applicable copyright laws.  All rights are reserved.  Any
// use in violation of the foregoing restrictions may subject the user to criminal
// sanctions under applicable laws, as well as to civil liability for the breach
// of the terms and conditions of this license.
//
// THIS SOFTWARE IS PROVIDED "AS IS".  NO WARRANTIES, WHETHER EXPRESS, IMPLIED
// OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
// USE OF THIS SOFTWARE FOR COMMERCIAL DEVELOPMENT AND/OR EDUCATION IS SUBJECT
// TO A CURRENT END USER LICENSE AGREEMENT (COMMERCIAL OR EDUCATIONAL) WITH
// CODE RED TECHNOLOGIES LTD.
//
//*****************************************************************************

#include "lpc_types.h"
#include "sbl_config.h"
#include "sbl_iap.h"
#include "integer.h"

#define BOOT_SECT_SIZE 	512

extern Bool  user_flash_erased; // from main_bootloader.c

int BlockDevGetSize(uint32_t *pdwDriveSize)
{
	*pdwDriveSize = (512 * 1024)- sector_start_map[USER_START_SECTOR];

	return 0;

}

int BlockDevWrite(uint32_t dwAddress, uint8_t * pbBuf)
{

	BYTE * firmware;
	firmware = (BYTE *)USER_FLASH_START;

	uint32_t offset;
	uint32_t length =512;
	offset = 512* dwAddress;

    if (offset < BOOT_SECT_SIZE)
	{
	  /* Can't write boot sector */
	}


    write_flash((unsigned *)(firmware + offset),(char *)pbBuf,length);
		   // [pbBuf casted to signed char pointer as that is what write_flash routine expects]

    return 0;

}
